#version 150

in vec4 vPosition;
in vec4 vNormal;
uniform mat4 mM;
uniform mat4 mV;
uniform mat4 mP;
uniform mat4 mR;        // matrix only for rotation of normals

uniform vec4 lightPosition;    // UPDATE!

out vec3 fN;                // UPDATE!  These go to the fragment shader for interpolation
out vec3 fE;
out vec3 fL;

void main () {

    //mat4 tiM = transpose(inverse(mM));
    //fN = (tiM*vNormal).xyz;
    fN = (mR*vNormal).xyz;
    fE = (mV*mM*vPosition).xyz;
    fL = (lightPosition).xyz;

    // If it's not a direction light (e.g. the sun), then L depends on the position of the vertex
    if (lightPosition.w != 0.0) {
        fL = lightPosition.xyz - (mV*mM*vPosition).xyz;
    }

    gl_Position = mP*mV*mM*vPosition;
}